% via ADDA algorithm (Wang, Wang, Li 2011)
% implemented by Benny Van Houdt
function Hg=SolveRiccati (A,B,C,D, precision)

if nargin<5
    precision=1e-15;
end

A = -A;
D = -D;

gamma1=max(diag(A));
gamma2=max(diag(D));
sA=size(A,1);
sD=size(D,1);
A=A+gamma2*eye(sA); %A holds A_gamma
D=D+gamma1*eye(sD); %D holds D_gamma
Dginv=D^(-1);
Vginv=(D-C*A^(-1)*B)^(-1);
Wginv=(A-B*Dginv*C)^(-1);
Eg=eye(sD)-(gamma1+gamma2)*Vginv;
Fg=eye(sA)-(gamma1+gamma2)*Wginv;
Gg=(gamma1+gamma2)*Dginv*C*Wginv;
Hg=(gamma1+gamma2)*Wginv*B*Dginv;

neg=1; nfg=1;
iter = 0;
%while (neg*nfg> 10^(-15))
while (neg>precision)
    Vginv=Eg*(eye(sD)-Gg*Hg)^(-1);
    Wginv=Fg*(eye(sA)-Hg*Gg)^(-1);
    Gg=Gg+Vginv*Gg*Fg;
    Hg=Hg+Wginv*Hg*Eg;
    Eg=Vginv*Eg;
    Fg=Wginv*Fg;
    neg=norm(Eg,1); nfg=norm(Fg,1);
    eta=sqrt(nfg/neg);
    Eg=Eg*eta;
    Fg=Fg/eta;
    iter = iter + 1;
end